<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->
<script setup lang="ts">
import * as api from '../../api';
import * as util from '../../util';
import { Ref, ref, onMounted } from 'vue';
import { useApplicationStore } from '../../stores/application';
import { Group, Invitation } from '../../entities';
import InvitationList from '../../components/InvitationList.vue';

const applicationStore = useApplicationStore();
const loading = ref(false);
const search = ref('');
const groups: Ref<Group[]> = ref([]);
const invitations: Ref<Invitation[]> = ref([]);
const childComponentRef = ref<typeof InvitationList | null>(null);

onMounted(() => {
  initInvitations();
});

function reset() {
  loading.value = false;
  search.value = '';
  groups.value = [];
  invitations.value = [];
}

function initInvitations() {
  reset();
  loading.value = true;

  const groupPromise = api.groups.getAllGroups();
  const invitationPromise = api.invitation.getInvitations();

  groupPromise.then((result) => (groups.value = result));
  invitationPromise.then((result) => (invitations.value = result));

  api.allCatching([groupPromise, invitationPromise]).finally(() => (loading.value = false));
}

function requestCreateInvitation() {
  childComponentRef.value?.openCreateInvitation();
}
</script>

<template>
  <v-row>
    <v-col md="12">
      <v-card>
        <v-card-title>
          Liste der ausstehenden Einladungen
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
          <v-btn
            class="ml-6"
            fab
            small
            :color="util.CONFIG.MAIN_BAR_COLOR"
            @click="requestCreateInvitation"
            dark
            ><v-icon>mdi-plus</v-icon></v-btn
          >
        </v-card-title>
        <invitation-list
          :invitations="invitations"
          :loading="loading"
          :search="search"
          :showPermissions="applicationStore.session.user.permissions.includes('ADMIN')"
          :groups="groups"
          v-on:refresh="initInvitations"
          ref="childComponentRef"
        />
      </v-card>
    </v-col>
  </v-row>
</template>

<style scoped></style>
